Agda-2.3.0.1: A dependently typed functional programming language and proof assistant

Safe Haskell | Safe-Infered

Agda.Utils.Generics

Description

Contains some generic utility functions and reexports certain definitions from Data.Generics.

Synopsis

- module Data.Generics
- isString :: GenericQ Bool
- everythingBut :: (r -> r -> r) -> GenericQ Bool -> GenericQ r -> GenericQ r
- everywhereBut' :: GenericQ Bool -> GenericT -> GenericT
- everywhereButM' :: Monad m => GenericQ Bool -> GenericM m -> GenericM m

# Documentation

module Data.Generics

isString :: GenericQ Bool

everythingBut :: (r -> r -> r) -> GenericQ Bool -> GenericQ r -> GenericQ r

everywhereBut' :: GenericQ Bool -> GenericT -> GenericT

Same as everywhereBut except that when the stop condition becomes true, the function is called on the top level term (but not on the children).

everywhereButM' :: Monad m => GenericQ Bool -> GenericM m -> GenericM m